%define debug_package %{nil}
%define	py_setup	setup.py

%define python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)")

%if 0%{?fedora} || 0%{?centos} >= 7
%global         with_python3 1
%define python3_sitelib %(%{__python3} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(plat_specific=True))")
%else
%global         with_python3 0
%endif

%define Testing 0
%{?_with_Testing:%define Testing 1}

Summary:	Python API for libfixbuf

Packager:	Lawrence R. Rogers (lrr@cert.org)

Vendor:		CERT Network Situational Awareness
Name:		pyfixbuf
Version:	0.9.0
%if %{Testing}
Release:	2%{?dist}
%else
Release:	1%{?dist}
%endif
URL:		https://tools.netsa.cert.org/pyfixbuf/doc/index.html
License:	GPLv2
Group:		Applications/System

Source0:	%{name}-%{version}.tar.gz
BuildRoot:	%{buildroot}

%description
pyfixbuf is a Python API for libfixbuf, an implementation of the IPFIX
protocol used for building collecting and exporting processes. pyfixbuf
can be used to write applications, often called mediators, that collect and
export IPFIX. Mediators are useful in modifying, filtering, or adding to the
contents of a message before forwarding to another IPFIX collection point,
or converting IPFIX to another format (text, database, JSON, etc.).

%if 0%{?with_python2}
%package -n python2-%{name}
Summary: ForensicArtifacts.com Artifact Repository.
Obsoletes: %{name}
Provides: %{name} = %{version}
Provides: python-%{name} = %{version}
BuildRequires:	libfixbuf-devel >= 2.2.0
BuildRequires:	glib2-devel
BuildRequires:	python2 >= 2.6, %(basename python2) < 3.0
BuildRequires:	python2-devel

%description -n python2-%{name}
Python2-%{name} is a Python 2 API for libfixbuf, an implementation of the IPFIX protocol used for
building collecting and exporting processes. Python2-%{name} can be used to write applications,
often called mediators, that collect and export IPFIX. Mediators are useful in modifying,
filtering, or adding to the contents of a message before forwarding to another IPFIX collection
point, or converting IPFIX to another format (text, database, JSON, etc.).
%endif

%if 0%{?with_python3}
%package -n python%{python3_pkgversion}-%{name}
Summary: ForensicArtifacts.com Artifact Repository.
BuildRequires:	libfixbuf-devel >= 2.2.0
BuildRequires:	glib2-devel
BuildRequires:	python%{python3_pkgversion}
BuildRequires:	python%{python3_pkgversion}-devel
BuildRequires:	python%{python3_pkgversion}-setuptools

%description -n python%{python3_pkgversion}-%{name}
Python%{python3_pkgversion}-%{name} is a Python %{python3_pkgversion} API for libfixbuf,
an implementation of the IPFIX protocol used for building collecting and exporting
processes. Python%{python3_pkgversion}-%{name} can be used to write applications, often called
mediators, that collect and export IPFIX. Mediators are useful in modifying, filtering, or
adding to the contents of a message before forwarding to another IPFIX collection point, or
converting IPFIX to another format (text, database, JSON, etc.).

%endif

%prep
%setup

%build
%if 0%{?with_python2}
%py2_build
%endif
%if 0%{?with_python3}
%py3_build
%endif

%install
%{__rm} -rf %{buildroot}
%if 0%{?with_python2}
%py2_install
mkdir -p %{buildroot}/%{_docdir}/%{name}/samples
cp -pr samples/* %{buildroot}%{_docdir}/pyfixbuf/samples
%endif
%if 0%{?with_python3}
%py3_install
mkdir -p %{buildroot}/%{_docdir}/py%{python3_pkgversion}fixbuf/samples
cp -pr samples/* %{buildroot}%{_docdir}/py%{python3_pkgversion}fixbuf/samples
%endif

################################################################################################################
# Fix the Shebang problem for Python2 executables
################################################################################################################
%if 0%{?with_python2}
for s in %{buildroot}%{_docdir}/%{name}/samples/*
do
	file $s | grep -q -i 'python script' && sed --in-place '1s=python[^2]*=python2=' $s
done
%endif
%if 0%{?with_python3}
for s in %{buildroot}%{_docdir}/py%{python3_pkgversion}fixbuf/samples/*
do
	file $s | grep -q -i 'python script' && sed --in-place '1s=python[^3]*=python%{python3_pkgversion}=' $s
done
%endif

%clean
# %{__rm} -rf %{buildroot}

%if 0%{?with_python2}
%files -n python2-%{name}
%defattr(444, root, root, 0755)
%doc LGPL.txt LICENSE-OPENSOURCE.txt PKG-INFO
%attr(0644, root, root)	%{python2_sitelib}/%{name}-%{version}-py*.egg-info
%attr(0755, root, root) %{python2_sitelib}/%{name}
%attr(0644, root, root) %{_docdir}/%{name}/samples/*
%endif

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-%{name}
%defattr(444, root, root, 0755)
%doc LGPL.txt LICENSE-OPENSOURCE.txt PKG-INFO
%attr(0644, root, root)	%{python3_sitelib}/%{name}-%{version}-py*.egg-info
%attr(0755, root, root) %{python3_sitelib}/%{name}
%attr(0644, root, root) %{_docdir}/py%{python3_pkgversion}fixbuf/samples/*
%endif


%changelog
%if %{Testing}
* Thu Mar 10 2022 Lawrence R. Rogers <lrr@cert.org> 0.9.0-2
* Release 0.9.0-2
	Rebuilt with the testing version of libfixbuf
%endif

* Tue Mar  1 2022 Lawrence R. Rogers <lrr@cert.org> 0.9.0-1
* Release 0.9.0-1
	Added compatibility for fixbuf-3.0; pyfixbuf supports fixbuf-2.2 and later.
	The pyfixbuf module no longer imports the YAF_LIST variables from pyfixbuf.yaflists. Users must explicitly import those variables.
	Updated the documentation, included programs, and cert_ipfix.xml file to use the same CERT Information Element names as YAF 3.0.0.
	  Note that the element names defined by the pyfixbuf.yaflists module have not changed.
	Fixed several bugs.
	Enhanced documentation and self-tests.

* Mon Jan  4 2021 Lawrence R. Rogers <lrr@cert.org> 0.8.1-2
* Release 0.8.1-2
	Rebuilt for libfixbuf-2.4.1.
	Also no longer making the Python 2 version.

* Thu Nov 14 2019 Lawrence R. Rogers <lrr@cert.org> 0.8.1-1
* Release 0.8.1-1
        Version 0.8.1.
		Fixed a bug setting IPv6 addresses on a record in Python 3.x.
		Fixed a bug when using IPv6 addresses in a basicList.

* Fri Aug 30 2019 Lawrence R. Rogers <lrr@cert.org> 0.8.0-1
* Release 0.8.0-1
        Version 0.8.0.
	Built for Python 2 and Python 3

* Fri Aug 30 2019 Lawrence R. Rogers <lrr@cert.org> 0.7.0-3
* Release 0.7.0-3
        Rebuilt for libfixbuf-2.4.0.

* Fri Apr 19 2019 Lawrence R. Rogers <lrr@cert.org> 0.7.0-2
* Release 0.7.0-2
        Rebuilt for libfixbuf-2.3.1.

* Mon Mar 18 2019 Lawrence R. Rogers <lrr@cert.org> 0.7.0-1
* Release 0.7.0-1
	Changed the STL and STML classes to raise an Exception when the user specifies a Template that has an ID of 0.
	Changed the Record class to allow an Python object of type bytearray for information elements whose type is OCTET_ARRAY or MAC_ADDR.
	Fixed a bug that could cause a Session to have a pointer to an invalid Template.
	Changed libfixbuf requirement to v2.2.0 or later.

* Thu Nov 29 2018 Lawrence R. Rogers <lrr@cert.org> 0.6.0-1
* Release 0.6.0-1
	Added a new sample script to visualize IPFIX data: dump_ipfix_metadata.py.
	Fixed a bug when converting a MAC address to text.
	Fixed several bugs that caused either exceptions or crashes.
	Requires libfixbuf-2.2.0.

* Fri Aug 31 2018 Lawrence R. Rogers <lrr@cert.org> 0.5.0-1
* Release 0.5.0-1
	Added several new sample scripts: to find records by IP address, to find records by DNS name, to find records on an unusual port
	Added the cert_ipfix.xml file as resource, and added a new pyfixbuf.cert module for access to it.
	Added the ability to invoke a callback function when a new Template object is read.
	Added new iteration methods to Templates and Records.
	Added a recursive Record iterator for visiting items in a subTemplateMultiList or subTemplateList.
	Made many additional changes, both visible and internal, and fixed several bugs.

* Thu Jul 12 2018 Lawrence R. Rogers <lrr@cert.org> 0.4.0-1
* Release 0.4.0-1
	Added support for parsing a file or a string as an XML registry of information elements to add to an information model.
	Fixed bugs in hanlding of floating point values and signed integers.
	Requires libfixbuf-2.1.0.

* Fri Jun  8 2018 Lawrence R. Rogers <lrr@cert.org> 0.3.0-1
* Release 0.3.0-1
	Rebuilt for libfixbuf 2.0.0
	Fix handling of floating point values.

* Thu Nov  9 2017 Lawrence R. Rogers <lrr@cert.org> 0.2.2-2
* Release 0.2.2-2
	Rebuilt for libfixbuf 1.8.0-1.

* Tue Mar 28 2017 Lawrence R. Rogers <lrr@cert.org> 0.2.2-1
* Release 0.2.2-1
	Fix Memory Leaks.

* Wed Jan 18 2017 Lawrence R. Rogers <lrr@cert.org> 0.2.1-1
* Release 0.2.1-1
	Minor Improvements.
	New sample scripts.
	Bug Fixes in sample scripts.

* Tue Oct 20 2015 Lawrence R. Rogers <lrr@cert.org> 0.2.0-3
* Release 0.2.0-3
	Rebuilt for libfixbuf-1.7.1.

* Wed Jul  1 2015 Lawrence R. Rogers <lrr@cert.org> 0.2.0-2
* Release 0.2.0-2
	Rebuilt for libfixbuf-1.7.0.

* Mon Feb  2 2015 Lawrence R. Rogers <lrr@cert.org> 0.2.0-1
* Release 0.2.0-1
	API Improvements.
	Added the ability to auto-generate templates from collected data without having to define records.
	New BasicList Class.
	Improvements in accessing and creating structured data elements.
	New sample mediators including full YAF mediators.
	Bug Fixes.

* Tue Dec  2 2014 Lawrence R. Rogers <lrr@cert.org> 0.1.0-1
* Release 0.1.0-1
	Initial release
